Subject: Re: [linux-usb] OHCI fix for Belkin BusPort card on PowerMac

From: "Gregory P. Smith" <[email-masked]>
Date: Mon, 6 Dec 1999 15:24:14 -0800

On Mon, Dec 06, 1999 at 02:23:12PM -0800, [email-masked] wrote:
> 
> I am running:
> PowerMac 8500 (604 processor)
> USB BusPort from Belkin (Model: F5U005-MAC) PCI USB card
> 2.2.12 kernel (self compiled)
> 2.3.29 USB stack from Paul Mackerras's rsync tree
> opendis-0.0.3-pre4 from http://digitalux.netpedia.net
...
> However, when requesting more data then the camera had to give the returned
> status was "9" and not "0".  The OHCI driver interpreted this as an error and
> subsequently the user level program would think no data had been returned.
> 
> After verifing the data to be correct I applied a very simple correction of:
> 
> /* Thinking this is what my controler returns when it is done? */
> #define USB_ST_EOF           9
> 
> and used that to signal the ohci.c and dc2xx.c drivers that the "End of File"
> had been reached.
> 
> My final question is:  Could this status be the same status as
> 
> #define USB_ST_DATAUNDERRUN   -9
> 
> or What does "data under run" mean?

Data underrun means the controller received less data that it asked
for in a transfer.  This is not really an error in many situations;
try modifying the dc2xx driver to accept it.

> It is obvious to me that my card has some unique status codes and I may run
> into this in the future.  It is for this reason I will not include patches for
> any of this unless others are like me with this type of card; trying to get 
> bulk messages to work.

It's not your card, its all controllers and a general "all slightly
different" state of the HCDs at the moment.  We're working on fixing
this with a move to a new cleaner device <-> usb stack/hcd interface.

-- 
Gregory P. Smith   pgp: http://suitenine.com/greg/pgp/
                   C379 1F92 3703 52C9 87C4  BE58 6CDA DB87 105D 9163